function asym_game
% identifies an ESS in the asymetric game with a user defined
% payoff matrix PM
% works for a GENERIC payoff matrix, may include non-ESSs for non-generic

%% define a payoff matirx
% this particular one is an owner-intruder game
V=10; % reward for having the resource
C=2; % cost of fighting
PM = [(V-C)/2        V    (3*V-C)/4  (3*V-C)/4;
       0            V/2      V/4         V/4  ;
      (V-C)/4     3*V/4      V/2     (2*V-C)/2;
      (V-C)/4     3*V/4   (2*V-C)/2     V/2 ];

s={'Hawk ', 'Dove ', 'Bourgeois ', 'Marauder '}; % give names to strategies
 
%% actual calculations  
n=size(PM,1); % get the number of strategies
max_P = max(PM,[],1); % identify maximal payoff to p1 given s2
BR = (max_P(ones(n,1), :) == PM); % identify candidates for best responses
ESS_candidates = diag(BR==1);
    % diag(BR) returns the diagonal of BR
    % it is 1 at places when there is an ESS (in generic case)
    % in non-generic case, there may be more than 1 best response and thus
    % the above may identify a strategy that is not actually an ESS
if sum(ESS_candidates)==0
    disp('There is no ESS')
elseif sum(ESS_candidates)==1 %only one ESS
    disp(['ESS is: ' s{ESS_candidates}]); % displays ESS(s)
else    
    disp(['ESSs are: ' s{diag(BR==1)}]); % displays ESS(s)
end; 
end
